var modelsData = [
		{ name: 'Unknown Mac', skin: 'iBookG4.png',
				screenX: 76, screenY: 40, closeX: 74, closeY: 34, hintAdjust: 0, portable: false },
		{ name: 'iBook G4', 	skin: 'iBookG4.png',
				screenX: 76, screenY: 40, closeX: 74, closeY: 34, hintAdjust: 0, portable: true },
		{ name: 'MacBook (white)', 	skin: 'MacBookWhite.png',
				screenX: 76, screenY: 40, closeX: 74, closeY: 34, hintAdjust: 0, portable: true },	
		{ name: 'MacBook (black)', 	skin: 'MacBookBlack.png',
				screenX: 76, screenY: 40, closeX: 74, closeY: 34, hintAdjust: 0, portable: true },					
		{ name: 'MacBook Pro', skin: 'MacBookPro.png',
				screenX: 76, screenY: 43, closeX: 74, closeY: 41, hintAdjust: 0, portable: true },
		{ name: 'PowerBook G4', skin: 'PowerBookG4.png',
				screenX: 76, screenY: 43, closeX: 74, closeY: 41, hintAdjust: -18, portable: true },				
		{ name: 'PowerBook Pismo', skin: 'PowerBookPismo.png',
				screenX: 76, screenY: 40, closeX: 74, closeY: 41, hintAdjust: -11, portable: true },									{ name: 'iMac (Aluminum)', skin: 'iMacBlack.png',
				screenX: 75, screenY: 24, closeX: 72, closeY: 23, hintAdjust: 0, portable: false },		
		{ name: 'iMac G5', skin: 'iMacG5.png',
				screenX: 75, screenY: 28, closeX: 69, closeY: 23, hintAdjust: 0, portable: false },	
		{ name: 'iMac (iSight)	', skin: 'iMac_iSight.png',
				screenX: 75, screenY: 28, closeX: 69, closeY: 23, hintAdjust: 0, portable: false },				
		{ name: 'iMac G4', skin: 'iMacG4.png',
				screenX: 76, screenY: 30, closeX: 69, closeY: 32, hintAdjust: -3, portable: false },
		{ name: 'Mac Pro', skin: 'MacPro.png',
				screenX: 93, screenY: 45, closeX: 67, closeY: 32, hintAdjust: -2, portable: false },					
		{ name: 'PowerMac G5', skin: 'PowerMacG5.png',
				screenX: 93, screenY: 45, closeX: 67, closeY: 32, hintAdjust: -2, portable: false },		
		{ name: 'PowerMac G4', skin: 'PowerMacG4.png',
				screenX: 91, screenY: 38, closeX: 57, closeY: 30, hintAdjust: -1, portable: false },	
		{ name: 'PowerMac G4 (QS)', skin: 'PowerMacG4QS.png',
				screenX: 91, screenY: 38, closeX: 57, closeY: 30, hintAdjust: 0, portable: false },					
		{ name: 'PowerMac G4 (MDD)', skin: 'PowerMacG4MDD.png',
				screenX: 91, screenY: 38, closeX: 57, closeY: 30, hintAdjust: 0, portable: false },
		{ name: 'PowerMac G4 (Cube)', skin: 'PowerMacG4Cube.png',
				screenX: 91, screenY: 38, closeX: 80, closeY: 30, hintAdjust: 0, portable: false },						
		{ name: 'Mac mini', skin: 'Macmini.png',
				screenX: 83, screenY: 46, closeX: 82, closeY: 45, hintAdjust: -2, portable: false },						
		{ name: 'eMac G4', skin: 'eMacG4.png',
				screenX: 75, screenY: 36, closeX: 72, closeY: 30, hintAdjust: -2, portable: false },
				
		{ name: 'Minimal', skin: 'minimal.png',
				screenX: 76, screenY: 46, closeX: 72, closeY: 45, hintAdjust: 0, portable: true },
		{ name: 'Cinema Display', skin: 'CinemaDisplay.png',
				screenX: 80, screenY: 43, closeX: 82, closeY: 43, hintAdjust: 0, portable: true },				
		{ name: 'iPod-like skin', skin: 'iPodLike.png',		
				screenX: 72, screenY: 12, closeX: 72, closeY: 10, hintAdjust: 0, portable: true },					
		{ name: 'iPhone', skin: 'iPhone.png',		
				screenX: 76, screenY: 44, closeX: 60, closeY: 40, hintAdjust: 0, portable: true },			
		{ name: 'AppleTV', skin: 'AppleTV.png',		
				screenX: 88, screenY: 38, closeX: 82, closeY: 35, hintAdjust: 0, portable: true },								
		{ name: 'Xbox 360', skin: 'Xbox360.png',
				screenX: 90, screenY: 40, closeX: 83, closeY: 36, hintAdjust: -1, portable: true },										
		{ name: 'Nintendo DS Lite', skin: 'NintendoDSLite.png',
				screenX: 75, screenY: 25, closeX: 25, closeY: 16, hintAdjust: 0, portable: true },					
		{ name: 'Nintendo Wii', skin: 'Wii.png',
				screenX: 89, screenY: 41, closeX: 83, closeY: 36, hintAdjust: 0, portable: true },							
		{ name: 'Sony PSP', skin: 'SonyPSP.png',
				screenX: 75, screenY: 43, closeX: 34, closeY: 36, hintAdjust: -1, portable: true },						
		{ name: 'Sony PS3', skin: 'PS3.png',
				screenX: 90, screenY: 38, closeX: 83, closeY: 36, hintAdjust: -1, portable: true }						
	];
	
var layoutNumberTimer = { timer: null, current: 0 };
var processesListSheetTimer = { timer: null, current: 0 };

var currentActiveWindow = -1;


var currentScreenX = 0;
var currentScreenY = 0;
var currentScreenW = 150;
var currentScreenH = 106;

var extraAppPicture = "Images/extraAppButton.png";

var tabGeneral = 1;
var tabInformation = 2;
var tabAppearance = 3;
var tabGrowl = 4;

var currentTab = tabGeneral;

var currentMod = 0;

var cacheLock = true;

var firstUpdateSensors = false;

var timerForHint = { timer: null, current: 0 };

var sShow = 1;
var sDontShow = 0;
var sInfoButton = 2; //always show + paddingLeft

var dockChanged = true;

var dockIconsData = [
	{ id: 'Processor', name: 'Processor', glyph: 'Processor.png', show: sShow, size: 14, left: 0, obj: 0, action: "showWindow(0)", hintPlus: 0 },
	{ id: 'Memory', name: 'Memory', glyph: 'Memory.png', show: sShow, size: 14, left: 0, obj: 0, action: "showWindow(1)", hintPlus: 0 },
	{ id: 'Storage', name: 'Storage', glyph: 'Storage.png', show: sShow, size: 14, left: 0, obj: 0, action: "showWindow(2)", hintPlus: 0 },
	{ id: 'Sensors', name: 'Sensors', glyph: 'Sensors.png', show: sShow, size: 14, left: 0, obj: 0, action: "showWindow(3)", hintPlus: -2 },
	{ id: 'Network', name: 'Network', glyph: 'Network.png', show: sShow, size: 14, left: 0, obj: 0, action: "showWindow(4)", hintPlus: -5 },
	{ id: 'Battery', name: 'Battery', glyph: 'Battery.png', show: sShow, size: 14, left: 0, obj: 0, action: "showWindow(5)", hintPlus: 0 },
	{ id: 'Preferences', name: 'Preferences', glyph: 'Info.png', show: sInfoButton, size: 14, left: 0, obj: 0, action: "showBack(event)", hintPlus: 0 }
  ];
  
var dockSizeData = { width: 0, height: 0, left: 0, right: 0, iconsCount: 0, obj: 0 };

var dockAlreadyRendered = false;


var I18N_BATTERY_UNKNOWN;
var I18N_BATTERY_CHARGED;
var I18N_BATTERY_CHARGING;
var I18N_BATTERY_RUNNING;
var I18N_BATTERY_UNTILFULL;
var I18N_BATTERY_FULLYCHARGED;
var I18N_BATTERY_TIME;
var I18N_BATTERY_CYCLES;
var I18N_BATTERY_FULLCYCLES;
var I18N_BATTERY_LIFE;
var I18N_BATTERY_CALCULATING;
var I18N_SENSORS_BATTERY;
var I18N_SENSORS_DRIVE;
var I18N_SENSORS_FAN;

function localizeDynamicVars()
{
	 I18N_BATTERY_UNKNOWN = getLocalizedString('Unknown');
	 I18N_BATTERY_CHARGED = getLocalizedString('Charged');
	 I18N_BATTERY_CHARGING = getLocalizedString('Charging');
	 I18N_BATTERY_RUNNING = getLocalizedString('Running');
	 I18N_BATTERY_UNTILFULL = " "+getLocalizedString('until full');	
	 I18N_BATTERY_FULLYCHARGED = getLocalizedString('Battery is charged');
	 I18N_BATTERY_TIME = getLocalizedString('Time');
	 I18N_BATTERY_CYCLES = getLocalizedString('Cycles');
	 I18N_BATTERY_FULLCYCLES = getLocalizedString('full charge cycles');
	 I18N_BATTERY_LIFE = getLocalizedString('Life');
	 I18N_BATTERY_CALCULATING = getLocalizedString('Calculating');
	 I18N_SENSORS_BATTERY = getLocalizedString('Battery');
	 I18N_SENSORS_DRIVE = getLocalizedString('Drive');
	 I18N_SENSORS_FAN = getLocalizedString('Fan');
}

function setBackCloseBoxOffset()
{
	widget.setCloseBoxOffset( 15, 15);
}

function restoreCloseBoxOffset()
{
	widget.setCloseBoxOffset( modelsData[currentMod].closeX, modelsData[currentMod].closeY);
}

function showHideBatteryButton(show)
{
	dockIconsData[5].show = show ? sShow : sDontShow;
}

function redrawModel()
{
	var cc = widget.preferenceForKey("currentModel");
	if (!cc) cc = m_iBookG4;
	setTimeout('renderModel('+cc+')',50);
}

function renderModel(currentModel)
{

	currentMod = currentModel; 
	
	currentScreenX = modelsData[currentModel].screenX;
	currentScreenY = modelsData[currentModel].screenY;
	
	if (window.widget){widget.setPreferenceForKey(currentModel, "currentModel");}
	
	o('machineImg').src = 'Skins/'+modelsData[currentModel].skin;
	o('fliprollie').style.display = 'none';
	o('flip').style.display = 'none';
	o('screen').style.left = currentScreenX;
	o('screen').style.top = currentScreenY;
	o('screen').style.display = "block";
	
	o('dockHint').style.top = currentScreenY + 65 + "px";
	
	restoreCloseBoxOffset();
		
	if ( !dockAlreadyRendered )	
	{
		dockSizeData.obj = o('dock');	
		var newDockHTML = "<div id='dockSep'></div>";
		var dockSize = 0;
		var dockIcon;
		var addStyle = "";
		for ( dockIcon in dockIconsData )
			{
				dockIconsData[dockIcon].left = (dockIcon*14)+4;	
				newDockHTML += "<img src='Icons/" +dockIconsData[dockIcon].glyph+ "' id='dock" +dockIconsData[dockIcon].id+"' width="+dockIconsData[dockIcon].size+" height="+dockIconsData[dockIcon].size+" style='left: "+dockIconsData[dockIcon].left+"'>";		
				dockSize += dockIconsData[dockIcon].size;
		}
		dockSize += 10;
		dockSizeData.obj.innerHTML = newDockHTML;	
		dockSizeData.width = dockSize;
		dockSizeData.height = 16;	
		dockAlreadyRendered = true;
	}
	
	dockSizeData.left = dockSizeData.right = dockSizeData.obj.style.left = dockSizeData.obj.style.right = Math.round( (currentScreenW-dockSize)/2 );
	
	
	
	for ( dockIcon in dockIconsData )
		dockIconsData[dockIcon].obj = o('dock'+dockIconsData[dockIcon].id);
		
	for ( type in dockIconsData )
		{	
			if ( type == dockIconsData.length-1 ) break;
			o('window'+dockIconsData[type].id).style.top = currentScreenY;
			o('window'+dockIconsData[type].id).style.left = currentScreenX;
			o('window'+dockIconsData[type].id+'_title').innerText = dockIconsData[type].name; 
		}
	
	o('summary').style.left = currentScreenX;
	o('summary').style.top = currentScreenY;
	
	o('lockBtn').style.left = currentScreenX + 127;
	o('lockBtn').style.top = currentScreenY + 6;
	
	renderDock();
	
}

function localizeAndAlignItem(id, name, tryToAlign)
{
	var alignedValue = null;
	o(id).innerHTML = getLocalizedString(name);
	if ( tryToAlign ) {
		if ( alignedValue = getLocalizedAligns(name) )	{
			o(id).style.left = alignedValue+"px"; } }
}

function localizeInterface()
{	
	for ( var dockIcon in dockIconsData )
		{
			dockIconsData[dockIcon].name = getLocalizedString(dockIconsData[dockIcon].id);
			dockIconsData[dockIcon].hintPlus = getLocalizedAligns(dockIconsData[dockIcon].id);	
			if ( dockIcon == dockIconsData.length-1 ) break;
			o('window'+dockIconsData[dockIcon].id+'_title').innerText = dockIconsData[dockIcon].name; 			
		}
	
	for ( var sect in sectionTypes )
		sectionTypes[sect].title = getLocalizedString(sectionTypes[sect].englishName);		

	for ( var notif in notificationTypes)
		notificationTypes[notif].title = getLocalizedString(notificationTypes[notif].englishName);	
	
	localizeAndAlignItem('activeMemoryLabel','Active',false);	
	localizeAndAlignItem('wiredMemoryLabel','Wired',false);	
	localizeAndAlignItem('inactiveMemoryLabel','Inactive',false);	
	localizeAndAlignItem('freeMemoryLabel','Free',false);	
	localizeAndAlignItem('swapLabel','Swap',false);

	localizeAndAlignItem('cpuSensLabel','ProcessorSensors',false);
	
	localizeAndAlignItem('intAddressLabel','Internal IP Address',false);
	localizeAndAlignItem('extAddressLabel','External IP Address',false);

	localizeAndAlignItem('mouseChargeLabel','Mouse',true);
	localizeAndAlignItem('keyboardChargeLabel','Keyboard',true);

//	o('reginput').value = getLocalizedString('Enter your key');
//	localizeAndAlignItem('registrationLabel','Registration:',false);
//	localizeAndAlignItem('tyfrLabel','Thank you for registration!',false);
//	localizeAndAlignItem('ysniLabel','Your serial # is',false);	
	localizeAndAlignItem('websiteBut','Web-site',false);
	localizeAndAlignItem('supportBut','Support',false);
	localizeAndAlignItem('autolockLabel','Lock windows',false);
	localizeAndAlignItem('extraAppLabel','Extra-button application:',true);	
	localizeAndAlignItem('returnBut','Return',false);
	localizeAndAlignItem('updateTimesLabel','Update intervals:',false);
	localizeAndAlignItem('trafficCountersLabel','Traffic counters:',true);	
	localizeAndAlignItem('networkInterfaceLabel','Network interface:',true);
	
	var selObjArray = ['Processor','Memory','Storage','Sensors','Network','Battery'];
	var tokensArray = ['Ultra-Low','Low','Normal','High'];
	var secondsShort = getLocalizedString('s');
	for ( var selObj in selObjArray )
		{
			var myObj = o('updateTime'+selObjArray[selObj]);
			for(var i=0; i<myObj.length; i++) 
				{
					if ( forceEnglish && myObj.options[i].tag ) { myObj.options[i].innerHTML = myObj.options[i].tag; continue; }
					myObj.options[i].tag = myObj.options[i].innerHTML;	
					myObj.options[i].innerHTML = myObj.options[i].innerHTML.replace(/^(\d+)s/,'$1'+secondsShort);
					for(var regx in tokensArray) 
						{			
							myObj.options[i].innerHTML = myObj.options[i].innerHTML.replace(new RegExp(tokensArray[regx], 'gi'),getLocalizedString(tokensArray[regx])); 
						}
				}
		}
	
	var selObj = o('trafficCounterTypeSel');
	selObj.options[0].innerHTML = getLocalizedString('Default (Reset after each login)');
	selObj.options[1].innerHTML = getLocalizedString('(Daily) Reset at 0:00 AM each day');
	selObj.options[2].innerHTML = getLocalizedString('(Weekly) Reset on mondays');
	selObj.options[3].innerHTML = getLocalizedString('(Monthly) Reset on 1st day of a month');
	selObj.options[4].innerHTML = getLocalizedString('(Monthly) Reset on specific day of your choice');	
	selObj.options[5].innerHTML = getLocalizedString('Manual resetting');		
	
	localizeAndAlignItem('sectionsLabel','Sections layout:',false);
	
	localizeAndAlignItem('growlNotificationEnabledLabel','Enable notification',false);	
	localizeAndAlignItem('growlCheckInterval','Interval:',true);	
	localizeAndAlignItem('growlTriggerOnLabel','Turn on:',true);
	localizeAndAlignItem('growlDisableLabel','Turn on/off:',true);
	localizeAndAlignItem('growlNotificationsTitle','notifications',false);
	
	selObj = o('growlCheckTimes');
	var minutesShort = getLocalizedString('m');
	for(var i=0; i<selObj.length; i++) 
		{
			if ( forceEnglish && selObj.options[i].tag ) { selObj.options[i].innerHTML = selObj.options[i].tag; continue; }
			selObj.options[i].tag = selObj.options[i].innerHTML;	
			selObj.options[i].innerHTML = selObj.options[i].innerHTML.replace(/(\d+)s/,'$1'+secondsShort);
			selObj.options[i].innerHTML = selObj.options[i].innerHTML.replace(/(\d+)m/,'$1'+minutesShort);	
		}
	
	selObj = o('growlDisableSel');
	selObj.options[0].innerHTML = getLocalizedString('Disable Growl');
	selObj.options[1].innerHTML = getLocalizedString('Enable Growl');
	selObj.options[2].innerHTML = getLocalizedString('*Enable Growl (disable it when idle)');	
	
	localizeAndAlignItem('counterResetButton','Reset',false);
	localizeAndAlignItem('counterStatsButton','Stats',false);
	
	var tabNames = ['General','System','Appearance','Other'];
	for ( var tab in tabNames )
		{
			var tabN = tabNames[tab];
			try {
				var alignInfo = getLocalizedAligns(tabN);
				o('prefTabText_'+tabN).innerText = getLocalizedString(tabN);
				o('prefTabText_'+tabN).style.width = alignInfo.width+'px';
				o('prefTab'+tabN).style.left = alignInfo.left+'px';			
			} catch(e) { /*may be an error here*/ }
		}
	
	localizeAndAlignItem('skinLabel','Widget skin:',false);	
	localizeAndAlignItem('wallpaperLabel','Wallpaper picture:',false);	
	localizeAndAlignItem('desktopColorLabel','Desktop text color:',false);		
	localizeAndAlignItem('unitsLabel','Units:',true);	

	localizeAndAlignItem('diskIconsLabel','Disk icons',false);
	localizeAndAlignItem('saveStateLabel','Auto-restore state',false);
	
	selObj = o('skinSel');
	for(var i=0; i<selObj.length; i++)
		if ( selObj.options[i].innerHTML == 'Minimal skin' ) selObj.options[i].innerHTML = getLocalizedString('Minimal skin');		
	
	selObj = o('desktopColorSel');
	for(var i=0; i<selObj.length; i++)
		 selObj.options[i].innerHTML = getLocalizedString(selObj.options[i].innerHTML);		
		 
	selObj = o('tempTypeSel');
	selObj.options[0].innerHTML = "&#176;C ("+getLocalizedString("Celsius")+")";
	selObj.options[1].innerHTML = "&#176;F ("+getLocalizedString("Fahrenheit")+")";
	
//	selObj = o('ipodSkinSel');
//	var ipodColorsArray = ['White','Black','Silver','Gold','Blue','Green','Pink'];
//	for(var i=0; i<selObj.length; i++)
//		for(var regx in ipodColorsArray) 
//			selObj.options[i].innerHTML = selObj.options[i].innerHTML.replace(new RegExp(ipodColorsArray[regx], 'gi'),getLocalizedString(ipodColorsArray[regx])); 
	
	o('languageSel').options[1].innerText = "System native ("+langName+")";

	localizeDynamicVars();
	
	
//	localizeAndAlignItem('','',false);	

}

function getNativeEnglishAligns(what)
{
	switch(what)
		{
			case 'Network':
			case 'Battery':
			case 'Sensors':			
			case 'Preferences':
				return 0;
			case 'General':
				return { width: 30, left: 28 };
			case 'System':
				return { width: 30, left: 85 };
			case 'Appearance':
				return { width: 30, left: 139 };
			case 'Other':
				return { width: 30, left: 218 };
			case 'Mouse':
				return 12;
			case 'Keyboard':
				return 70;
			case 'Tool:':
				return 150;
			case 'Extra-button application:':
				return 40;
			case 'Network interface:':
				return 180;
			case 'Traffic counters:':
				return 184;
			case 'Keyword:':
				return 162;
		}
	return -256;
}


function renderDock()
{
	if (!dockChanged) return;	
	for ( var i = 0; i < dockIconsData.length; i++ )
		{	
			try {	
				dockIconsData[i].obj.style.width = dockIconsData[i].size;
				dockIconsData[i].obj.style.height = dockIconsData[i].size;
				dockIconsData[i].obj.style.left = dockIconsData[i].left;	
				if ( !dockIconsData[i].show ) dockIconsData[i].obj.style.opacity = 0.3;
				else dockIconsData[i].obj.style.opacity = 1.0;
				if ( dockIconsData[i].show == sInfoButton )
					{
						dockIconsData[i].obj.style.left = dockIconsData[i].left+3;
						o('dockSep').style.left = dockIconsData[i].left+1;
					}
			} catch(ex) {return;} 
		}
		
		try {
			dockSizeData.obj.style.left = dockSizeData.left;
			dockSizeData.obj.style.right = dockSizeData.right;
		} catch(ex) {return;} 
	
}

function checkCloseAndLockButtons(event)
{
	var x = event.clientX - currentScreenX;
	var y = event.clientY - currentScreenY;
	
//	if ( !event.type == "mouseup"
	if (  x >= 11 && x <= 22 && y >= 5 && y <= 16 )
		showWindow(-1); //clear all windows and show summary
	else if ( x >= 122 && x <= 140 && y >= 5 && y <= 16 )
		toggleLock();
	else if ( currentActiveWindow == 4 && x >= 19 && x <= 33 && y>=18 && y<=34 )
		showIPs();
	else if ( currentActiveWindow == 4 && x >= 59 && x <= 78 && y>=54 && y<= 67 )
		toggleAirport();
	else if ( currentActiveWindow == 4 && x >= 16 && x <= 29 && y>=55 && y<= 77 )
		{
			miniStatCore.setBluetoothPower_( !(miniStatCore.bluetoothPower()) );
			drawNetwork();
		}
	else if ( currentActiveWindow == 4 && x >= 36 && x <= 46 && y>=54 && y<= 63  )
		{
			miniStatCore.setBluetoothDiscoverable_( !(miniStatCore.bluetoothDiscoverable()) );		
			drawNetwork();
		}		
	else if ( currentActiveWindow == 0 && x >= 82 && x <= 138 && y>=66 && y<= 81 )
		showProcessesSheet();
	else if ( isProcessesSheetShown && x >= 19 && x <= 47 && y>=21 && y<= 75 )
	{
		var sortKey = getOption('processes-list-sort');
		if ( sortKey == 'r' )
			setOption('processes-list-sort','m');
		else 
			setOption('processes-list-sort','r');
			
		updateProcessesList();
	}
	
	
}

function showIPs()
{	
	o('internalAddr').value = getLocalizedString("Please wait...");
	o('externalAddr').value = getLocalizedString("Please wait...");
	o('IPsFrame').style.display = 'block';
	setTimeout('getIPs();',50);
}

function checkDock(event)
{
	var x = event.offsetX - currentScreenX;
	var y = event.offsetY - currentScreenY;
	var newDockSize = 10;

	if ( getOption('extrabutton') )
		{
			var xx = event.clientX - currentScreenX;
			var yy = event.clientY - currentScreenY;
			if ( xx > 0 && xx < 145 && yy > 0 && y < 105 )
				renderExtraAppButton(true);
			else
				renderExtraAppButton(false);
		}
		
	if ( x >= (dockSizeData.left+5) && x <= (currentScreenW-dockSizeData.right-2) && y >= (currentScreenH-dockSizeData.height) && y <= currentScreenH-2 )
		{
			var dockX = x-dockIconsData[0].left-5; 
			var dockY = y-(currentScreenH-dockSizeData.height);
			var dockIconNum = Math.floor((dockX+1)/14);
			
			if ( dockIconNum <= 0 ) dockIconNum = 1;
			if ( dockIconNum >= dockIconsData.length ) dockIconNum = dockIconsData.length;

			if ( event.type == "mouseup" )
				{
					eval(dockIconsData[dockIconNum-1].action);
					return;
				}
				
			//calculate new size of icons
			var lastLeftCoordinate = 0; var topDockIconID = -1;
			for ( var i = 0; i <= dockIconsData.length-1; i++ )
				{	
					var newSize = 14;
					switch (i)
						{
							case dockIconNum-1:
								newSize = 22;
								topDockIconID = i;
								break;
							case dockIconNum-2:
							case dockIconNum:
								newSize = 19;
								break;
						}
					dockIconsData[i].size = newSize;
					newDockSize += newSize;
					dockIconsData[i].left = lastLeftCoordinate+5;				
					lastLeftCoordinate += newSize;
				}
				dockChanged = true;
				dockSizeData.left = dockSizeData.right = Math.round( (currentScreenW-newDockSize)/2 );
				dockSizeData.width = newDockSize;
				
				if ( topDockIconID != -1 )
					{
						var hintX = dockIconsData[topDockIconID].left; 
						if ( hintX < dockSizeData.left ) hintX = dockSizeData.left;
						if ( dockIconsData[topDockIconID].id == 'Preferences' )  { hintX = currentScreenW-80;}
						if ( currentMod == 5 ) hintX += 17;
						if ( currentMod == 6 ) hintX += 10;
						o('dockHint').style.left = hintX+currentScreenX+modelsData[currentMod].hintAdjust+dockIconsData[topDockIconID].hintPlus;
 
						o('dockHint').innerText = dockIconsData[topDockIconID].name;
						o('dockHint').style.display = 'block';		
					}		
				renderDock();			
		}
		else
		{
			for ( var i = 0; i <= dockIconsData.length-1; i++ )
				{
					dockIconsData[i].size = 14;
					dockIconsData[i].left = i*14+4;
					newDockSize += 14;
				}
			dockSizeData.left = dockSizeData.right = Math.round( (currentScreenW-newDockSize)/2 );
			o('dockHint').style.display = 'none';
			dockChanged = true;
			renderDock();
			dockChanged = false;
		}
}

function resetDock()
{
	var newDockSize = 10;
	for ( var i = 0; i <= dockIconsData.length-1; i++ )
				{
					dockIconsData[i].size = 14;
					dockIconsData[i].left = i*14+4;
					newDockSize += 14;
				}
			dockSizeData.left = dockSizeData.right = Math.round( (currentScreenW-newDockSize)/2 );
			o('dockHint').style.display = 'none';
			dockChanged = true;			
			renderDock();
			dockChanged = false;
}

function getActiveWindow() { return currentActiveWindow; }

function drawLockIcon(what)
{

	if ( what == -1 )
		o('lockBtn').src = 'Images/Unlock.png';
	else
		o('lockBtn').src = 'Images/Lock.png';

}

function showWindowForSection(num)
{
	var showType = sectionTypes[sectionsConfiguration[CSL][num]].type;
	switch(showType)
		{
			case 'processor': showWindow(0); break;
			case 'memory': showWindow(1); break;
			case 'storage': showWindow(2); break;
			case 'sensors': showWindow(3); break;
			case 'network': showWindow(4); break;
			case 'battery': showWindow(5); break;			 
		}
}

function showWindow(id)
{
	var autoLockOpt = 0;
	
	if ( id == 5 && !getBatteryUpdatedStatus() ) return;
	if ( id == 3 && !firstUpdateSensors ) { resetUpdateCounters(); setUpdateWhatInfo('sensors'); updateInfo(true); firstUpdateSensors = true; }
	if ( id == 4 ) fillInterfacesList(); 
	
	if ( autoLockOpt = getOption('autolock') ) setupLock(1);
	
	o('IPsFrame').style.display = 'none';
	o('ProcessesListSheet').style.display = 'none';
	isProcessesSheetShown = false;
	
	for ( type in dockIconsData )
		{	
			if ( type == dockIconsData.length-1 ) break;
			o('window'+dockIconsData[type].id).style.display = 'none';	
		}

	
	currentActiveWindow = id;
	
	if ( id == -1 ) 
		{		
			setupLock(-1);
			o('summary').style.display = 'block';
			o('lockBtn').style.display = 'none';
			setUpdateWhatInfo('all');
			widget.setPreferenceForKey('desktop',"last-state-"+widget.identifier);
			return;
		}


	o('lockBtn').style.display = 'block';		
	
	o('summary').style.display = 'none';	
	o('window'+dockIconsData[id].id).style.display = 'block';	


	
	switch(id)
		{
			case 0: setUpdateWhatInfo('processor'); widget.setPreferenceForKey('desktop',"last-state-"+widget.identifier); drawProcessor(); break;
			case 1: setUpdateWhatInfo('memory'); widget.setPreferenceForKey('memory',"last-state-"+widget.identifier);  drawMemory(); break;
			case 2: setUpdateWhatInfo('storage'); widget.setPreferenceForKey('storage',"last-state-"+widget.identifier);  drawStorage(); break;
			case 3: setUpdateWhatInfo('sensors'); widget.setPreferenceForKey('sensors',"last-state-"+widget.identifier);  drawSensors(); break;
			case 4: setUpdateWhatInfo('network'); widget.setPreferenceForKey('network',"last-state-"+widget.identifier);  drawNetwork(); break;
			case 5: setUpdateWhatInfo('battery'); widget.setPreferenceForKey('battery',"last-state-"+widget.identifier);  drawBattery(); break;
		}

	updateInfo();

		
	if ( cacheLock && !autoLockOpt )
	{
		setupLock(1);
		setupLock(-1);
		cacheLock = false;
	}

}


function redrawProcessorsCount(count)
{
	var disp1 = 'block'; var disp2 = 'none';
	if ( count == 2 ) {	disp1 = 'none'; disp2 = 'block'; }			

	o('viewOneProc').style.display = disp1;
	o('viewTwoProc').style.display = disp2;
		
	o('twoProcSensors').style.display = disp2;
	o('oneProcSensor').style.display = disp1;	

}

function redrawBattery(yesOrNo)
{
	var draw = 'none';
	if ( yesOrNo )
		{	
			draw = 'block';
			dockIconsData[5].show = sShow;
		}
	else
		dockIconsData[5].show = sDontShow;

	o('sensorBatteryFrame').style.display = draw;
}

var reredraw = 0;

function redrawBG()
{	
	var newBG = getOption('wallpaperPic');
	var defaultBG = "Environment/Wallpapers/StandardAqua.png";
	
	if ( newBG == "custom" )
	 	{
			newBG = miniStatCore.wallpaperPicture();	
			if ( newBG == "nopicture" ) newBG = defaultBG;
		}
	else if ( !newBG )
		newBG = defaultBG;
	else
		newBG = "Environment/Wallpapers/" + newBG;
	
	o('screen').style.backgroundImage = "url("+newBG+")";
	o('sampleDesktopPicture').src = newBG;	 	
}

function switchWallpaper(toWhat)
 {
 	if ( toWhat == "custom" )
 	 {
 		newBG = miniStatCore.wallpaperPicture();	
		if ( newBG == "nopicture" ) 
			{
				setOption('wallpaperPic','custom');
				dropToTheOldWallpaper();
				widget.system('/bin/rm -f ~/Library/Widgets/wallpaper_miniStat2.png; /usr/bin/open wallpaperTool.app;',null);
				widget.openApplication('com.apple.dashboard.client'); 			
			}
 	 }
 	 else
 	 {
 	 	 //delete custom
 		 widget.system('/bin/rm -f ~/Library/Widgets/wallpaper_miniStat2.png;',null);
   	 }
			

    setOption('wallpaperPic',toWhat);
    redrawBG();		 			 	
 	 
 }


function setupHint(text)
{
	if (timerForHint.timer == null) 
		timerForHint.timer = setInterval('animateHintFading()',70);
	o('summaryHint').innerText = text;
		
	timerForHint.current = -text.length||10;	
	animateHintFading();
}

function animateHintFading()
{
	timerForHint.current++;
	
	if ( timerForHint.current > 10 )
		{
			clearInterval(timerForHint.timer);
			timerForHint.timer = null;
			o('summaryHint').style.opacity = 0.0;
			return;
		}
	else if ( timerForHint.current < 5 )
		o('summaryHint').style.opacity = 1.0;
	else
		o('summaryHint').style.opacity = 1-(timerForHint.current-5)/5;
}

function switchBackTab(newTab)
{
	if ( currentTab == newTab) return;
	
	var tabNames = ['none','General','System','Appearance','Other'];
	
	o('prefTabPadLeft_'+tabNames[newTab]).src = "Images/prefTabLeftBlacked.png";
	o('prefTabPadRight_'+tabNames[newTab]).src = "Images/prefTabRightBlacked.png";	
	o('prefTabPadLeft_'+tabNames[currentTab]).src = "Images/prefTabLeft.png";
	o('prefTabPadRight_'+tabNames[currentTab]).src = "Images/prefTabRight.png";		
	o('prefTabText_'+tabNames[newTab]).setAttribute('class','prefTabBlackedText');
	o('prefTabText_'+tabNames[currentTab]).setAttribute('class','prefTabText');	
	
	switch (newTab)
		{
			case tabGeneral:
				o('tabGeneralLayer').style.display = "block"; break;
			case tabInformation:	
				o('tabInformationLayer').style.display = "block"; break;
			case tabAppearance:	
				o('tabAppearanceLayer').style.display = "block"; break;			
			case tabGrowl:
				o('tabOtherLayer').style.display = "block"; setTimeout('switchNotificationTypeSel(0)',50); break;
		}	
	
	switch (currentTab)
		{
			case tabGeneral:
				o('tabGeneralLayer').style.display = "none"; break;
			case tabInformation:		
				o('tabInformationLayer').style.display = "none";	 break;
			case tabAppearance:
				o('tabAppearanceLayer').style.display = "none";	 break;		
			case tabGrowl:
				o('tabOtherLayer').style.display = "none";	 setTimeout('savePrefs(\'growl-trigger\')',50); break;				
		}
	
	currentTab = newTab;

}

function renderExtraAppButton(enabled)
{
	o('vertLineSmall').style.display = o('extraAppButton').style.display = enabled ? 'block' : 'none';
	o('vertLine').setAttribute('class', enabled ? 'vertLineWithButton' : 'vertLineWithoutButton' );
}

function renderLayoutNumbers(what)
{
	o('layoutHighlight').src = "Environment/Layout"+(what)+".png";
	o('layoutHighlight').style.display = 'block';
	o('layoutHighlight').style.opacity = 1.0;	

	if (layoutNumberTimer.timer) { clearInterval(layoutNumberTimer.timer); }
	layoutNumberTimer.current = -12;
	layoutNumberTimer.timer = setInterval("layoutHighlightAnim()",70);
	layoutHighlightAnim();
}

function layoutHighlightAnim()
{
	layoutNumberTimer.current++;

	if (layoutNumberTimer.current < 0) return;
	if (layoutNumberTimer.current > 5)
		{
			clearInterval(layoutNumberTimer.timer);
			layoutNumberTimer.timer = null;
			o('layoutHighlight').style.display = 'none';
		}
	else
		{
			o('layoutHighlight').style.opacity = 1-layoutNumberTimer.current/5;
		}
}

function redrawExtraAppPicture()
{
	extraAppPicture = miniStatCore.pathToApplicationIcon_(getOption('extrabuttonpath') || 'Activity Monitor') + ("?sdf="+Math.random());
	fadeExtraAppButton(true);
	fadeExtraAppButton(false);
}

function fadeExtraAppButton(what)
{
	o('extraAppButton').src = extraAppPicture;
	o('extraAppButton').style.opacity = what ? 1.0 : 0.85;
}

function showProcessesSheet()
{
	o('ProcessesListSheet').style.display = 'block';
	o('ProcessesListSheet').style.opacity = 0.2;
	o('ProcessesListSheet').style.clip = 'rect(68,126,68,0)';	

	if (processesListSheetTimer.timer) { clearInterval(processesListSheetTimer.timer); }
	processesListSheetTimer.current = 68;
	processesListSheetTimer.timer = setInterval("animProcessesSheetList()",50);
	animProcessesSheetList();
	updateProcessesList();
	
	widget.setPreferenceForKey('processes',"last-state-"+widget.identifier);
}

function animProcessesSheetList()
{
	processesListSheetTimer.current -= 8;

	if (processesListSheetTimer.current <= 0)
		{
			clearInterval(processesListSheetTimer.timer);
			processesListSheetTimer.timer = null;
			o('ProcessesListSheet').style.opacity = 1.0;
			o('ProcessesListSheet').style.clip = 'rect(0,126,68,0)';	
			o('ProcessesListSheet').style.top = -2;
			isProcessesSheetShown	 = true;
		}
	else
		{
			o('ProcessesListSheet').style.clip = 'rect('+processesListSheetTimer.current+',126,68,0)';	
			o('ProcessesListSheet').style.top = -processesListSheetTimer.current-1;		
			o('ProcessesListSheet').style.opacity = 0.2 + 0.8*(1-processesListSheetTimer.current/68);
		}

}