//Italian localization for miniStat2 widget
//translator: Nicola "ATMB" Del Monaco (atmb82@gmail.com)

var localizedStrings = new Array; 
var localizedAligns = new Array; 

var langName = "Italiano"; //language name

//mini-dock icons
localizedStrings['Processor'] = 'Processore'; 
localizedStrings['Memory'] = 'Memoria'; 
localizedStrings['Storage'] = 'Unità Disco'; 
	localizedAligns['Storage'] = -9;
localizedStrings['Sensors'] = 'Sensori'; 
	localizedAligns['Sensors'] = +3;
localizedStrings['Network'] = 'Rete'; 
	localizedAligns['Network'] = +12; 
localizedStrings['Battery'] = 'Batteria'; 
	localizedAligns['Battery'] = -2;
localizedStrings['Preferences'] = 'Preferenze'; 
	localizedAligns['Preferences'] = +6;

//processor view
////inherit from other sections

//memory view
localizedStrings['Active'] = 'Attiva'; 
localizedStrings['Wired'] = 'Wired'; 
localizedStrings['Inactive'] = 'Inattiva'; 
localizedStrings['Free'] = 'Libera'; 
localizedStrings['Swap'] = 'Swap'; 

//sensors view
localizedStrings['ProcessorSensors'] = 'Process.'; //!!shorter!! (a bit)
localizedStrings['Drive'] = 'Unità'; 
localizedStrings['Fan'] = 'Ventol.'; //!!shorter!!

//network view
localizedStrings['Internal IP Address'] = 'Indirizzo IP interno'; 
localizedStrings['External IP Address'] = 'Indirizzo IP esterno'; 
localizedStrings['Please wait...'] = 'Attendi...';
localizedStrings['No connection'] = 'Nessuna conn.'; //!!shorter!!

//batteries view
localizedStrings['Mouse'] = 'Mouse'; 
	localizedAligns['Mouse'] = 13;
localizedStrings['Keyboard'] = 'Tastiera'; 
	localizedAligns['Keyboard'] = 75;
localizedStrings['Unknown'] = 'Sconosciuto'; 
localizedStrings['Charging'] = 'In Carica'; 
localizedStrings['Charged'] = 'Caricato'; 
localizedStrings['Running'] = 'In uso'; 
localizedStrings['Time'] = 'Tempo'; 
localizedStrings['Cycles'] = 'Cicli'; 
localizedStrings['full charge cycles'] = 'cicli compl. di carica';  //!!shorter!!
localizedStrings['Life'] = 'Vita'; 
localizedStrings['Calculating'] = 'Calcolo in corso'; 
localizedStrings['until full'] = 'a car. completa'; //!!shorter!!
localizedStrings['Battery is charged'] = 'La batteria é carica'; 

/////////////
//preferences
localizedStrings['Return'] = 'Ritorna'; 
localizedStrings['General'] = 'Generale'; 
localizedStrings['System'] = 'Sistema'; 
localizedStrings['Appearance'] = 'Aspetto'; 
localizedStrings['Other'] = 'Altro'; 

//////tabs width and coords
localizedAligns['General'] = { width: 30, left: 32 }; //default: 0, 28
localizedAligns['System'] = { width: 30, left: 95 };//default: 0, 85
localizedAligns['Appearance'] = { width: 30, left: 153 }; //default: 0, 139
localizedAligns['Other'] = { width: 30, left: 211 };	//default: 0, 218

////general tab
localizedStrings['Your serial # is'] = 'Il tuo reg. code #';
localizedStrings['Thank you for registration!'] = 'Grazie per esserti registrato!'; 
localizedStrings['Web-site'] = 'Sito'; 
localizedStrings['Support'] = 'Supporto'; 
localizedStrings['Tool:'] = 'Util.:'; //!!shorter!!
	localizedAligns['Tool:'] = 148; 
localizedStrings['Registration:'] = 'Registrazione:'; 
localizedStrings['Enter your key'] = 'Inserisci il tuo reg. code'; 
localizedStrings['Autorun Dashboard'] = 'Esegui Dashboard autom.'; 
localizedStrings['Lock windows'] = 'Blocca finestre'; 
localizedStrings['Extra-button application:'] = 'Pulsante applicazione:';  //!!shorter!!

////information tab
localizedStrings['Update intervals:'] = 'Interv. per l\'aggiornam.:'; 
localizedStrings['Network interface:'] = 'Interfaccia di rete:'; 
	localizedAligns['Network interface:'] = 178; 
localizedStrings['Traffic counters:'] = 'Contatori di traffico:'; 
	localizedAligns['Traffic counters:'] = 178; 
localizedStrings['Ultra-Low'] = 'Molto Basso'; 
localizedStrings['Low'] = 'Basso'; 
localizedStrings['Normal'] = 'Normale'; 
localizedStrings['High'] = 'Alto'; 
localizedStrings['s'] = 's'; //seconds
localizedStrings['m'] = 'm'; //minutes

localizedStrings['Default (Reset after each login)'] = 'Predefinito (Azzera ad ogni login)';
localizedStrings['(Daily) Reset at 0:00 AM each day'] = 'Giornaliero (Azzera alle 00:00 ogni giorno)';
localizedStrings['(Weekly) Reset on mondays'] = 'Settimanale (Azzera il luned“)';
localizedStrings['(Monthly) Reset on 1st day of a month'] = 'Mensile (Azzera il primo giorno del mese)';
localizedStrings['(Monthly) Reset on specific day of your choice'] = 'Mensile (Azzera in un giorno a tua scelta)';
localizedStrings['Manual resetting'] = 'Azzeramento manuale';

localizedStrings['Reset'] = 'Azzera';
localizedStrings['Stats'] = 'Statis.';

localizedStrings['Sections layout:'] = 'Layout sezioni:';

////appearance tab
localizedStrings['Widget skin:'] = 'Skin:';
localizedStrings['Minimal skin'] = 'Skin essenziale';
localizedStrings['Wallpaper picture:'] = 'Immagine di sfondo:';
localizedStrings['New picture'] = 'Nuova';
localizedStrings['Restore'] = 'Riprist.'; //!!shorter!! (a bit)
localizedStrings['Desktop text color:'] = 'Colore testo desktop:'; //!!shorter!!
localizedStrings['Units:'] = 'Unità:';
localizedStrings['Celsius'] = 'Celsius';
localizedStrings['Fahrenheit'] = 'Fahrenheit';
localizedStrings['Units:'] = 'Unità:';
localizedStrings['Disk icons'] = 'Icone del disc';
localizedStrings['Auto-restore state'] = 'Auto-ristabilire';

////// colors
localizedStrings['White'] = 'Bianco';
localizedStrings['Black'] = 'Nero';
localizedStrings['Gray'] = 'Grigio';
localizedStrings['Green'] = 'Verde';
localizedStrings['Yellow'] = 'Giallo';
localizedStrings['Maroon'] = 'Marrone';
localizedStrings['Navy'] = 'Blu scuro';
localizedStrings['Red'] = 'Rosso';
localizedStrings['Blue'] = 'Blu';
localizedStrings['Purple'] = 'Porpora';
localizedStrings['Crimson'] = 'Cremisi';
localizedStrings['Gold'] = 'Dorato';  //for ipod's icon menu
localizedStrings['Silver'] = 'Argentato';  //for ipod's icon menu
localizedStrings['Pink'] = 'Rosa';  //for ipod's icon menu

//popup hints
localizedStrings['down/up speed'] = "velocità up/down";
localizedStrings['up traffic'] = "upload";
localizedStrings['down traffic'] = "download";
localizedStrings['Battery charge'] = 'Carica batteria';
localizedStrings['Time remaining'] = 'Tempo rimanente';
localizedStrings['Cycles count'] = 'Conteggio dei cicli';
localizedStrings['Mouse batteries'] = 'Batteria del mouse';
localizedStrings['Keyboard batteries'] = 'Batteria della tastiera';
localizedStrings['CPU Usage'] = 'Uso CPU';
localizedStrings['Free memory'] = 'Memoria libera';
localizedStrings['CPU heat'] = 'Temp. CPU'; 
localizedStrings['CPU #1 heat'] = 'Temp. CPU #1'; 
localizedStrings['CPU #2 heat'] = 'Temp. CPU #2'; 
localizedStrings['Battery heat'] = 'Temp. batteria'; 

//sections
localizedStrings['Processor usage'] = 'Uso processore';
localizedStrings['Processor #A usage'] = 'Uso processore #A';
localizedStrings['Processor #B usage'] = 'Uso processore #B';
localizedStrings['Hard-drive free space'] = 'Spazio libero sul disco rigido';
localizedStrings['Processor temperature'] = 'Temp. processore';
localizedStrings['Fan rotation speed'] = 'Velocità di rot. ventol.'; //!!shorter!!
localizedStrings['Uptime'] = 'Uptime';
localizedStrings['Load average'] = 'Media carico';
localizedStrings['Used memory'] = 'Memoria in uso';
localizedStrings['Inactive memory'] = 'Memoria inattiva';
localizedStrings['Wired memory'] = 'Memoria wired';
localizedStrings['Network bandwidth'] = 'Largh. banda di rete'; //!!shorter!!
localizedStrings['Download+Upload'] = 'Download+Upload';
localizedStrings['AirPort signal'] = 'AirPort segnale';
localizedStrings['Download traffic'] = 'Download';
localizedStrings['Upload traffic'] = 'Upload';
localizedStrings['Battery time remaining'] = 'Carica restante batt.'; //!!shorter!!
localizedStrings['Battery cycles'] = 'Cicli della batteria';
localizedStrings['Wireless mouse'] = 'Mouse wireless';
localizedStrings['Wireless keyboard'] = 'Tastiera wireless';

//growl stuff
localizedStrings['notifications'] = 'notifiche';
localizedStrings['-Select notification type to edit-'] = '-Scegli il tipo di notifica da modificare-';
localizedStrings['Enable notification'] = 'Abilita notifiche';
localizedStrings['Disable Growl'] = 'Disattiva Growl';
localizedStrings['Enable Growl'] = 'Attiva Growl';
localizedStrings['*Enable Growl (disable it when idle)'] = '*Attiva Growl (disabilita quando idle)';
localizedStrings['Turn on:'] = 'Attiva:';
	localizedAligns['Turn on:'] = 171; 
localizedStrings['Interval:'] = 'Intervallo:';	
	localizedAligns['Interval:'] = 153; 
localizedStrings['Turn on/off:'] = 'Att./Disatt.:';	//!!shorter!! (a bit)
	localizedAligns['Turn on/off:'] = 216; 
localizedStrings['System load is too high'] = 'Il carico del sistema é troppo alto';
localizedStrings['Low free memory'] = 'Memoria libera bassa';
localizedStrings['Processor is overheated'] = 'Il processore é surriscaldato';
localizedStrings['Traffic counters reset'] = 'Contatori del traffico di rete azzerati';
localizedStrings['Battery is running low'] = 'La batteria é quasi scarica';
